## org.apache.commons.collections
Class ExtendedProperties

    java.lang.Object
      java.util.Dictionary
          java.util.Hashtable
              org.apache.commons.collections.ExtendedProperties

All Implemented Interfaces:
  Cloneable, Map, Serializable

public class ExtendedProperties
extends Hashtable

This class extends normal Java properties by adding the possibility to use the same key many times concatenating the value strings instead of overwriting them.

Please consider using the `PropertiesConfiguration` class in Commons-Configuration as soon as it is released.

The Extended Properties syntax is explained here:

- Each property has the syntax `key = value`
- The key may use any character but the equal sign '='.
- value may be separated on different lines if a backslash is placed at the end of the line that continues below.
- If value is a list of strings, each token is separated by a comma ','.
- Commas in each token are escaped placing a backslash right before the comma.
- Backslashes are escaped by using two consecutive backslashes i.e. \\
- If a key is used more than once, the values are appended like if they were on the same line separated with commas.
- Blank lines and lines starting with character '#' are skipped.
- If a property is named "include" (or whatever is defined by setInclude() and getInclude() and the value of that property is the full path to a file on disk, that file will be included into the ConfigurationsRepository. You can also pull in files relative to the parent configuration file. So if you have something like the following: include = additional.properties Then "additional.properties" is expected to be in the same directory as the parent configuration file. Duplicate name values will be replaced, so be careful.

Here is an example of a valid extended properties file:

          # lines starting with # are comments

          # This is the simplest property
          key = value

          # A long property may be separated on multiple lines
          longvalue = aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa \
                      aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa

          # This is a property with many tokens
          tokens_on_a_line = first token, second token

          # This sequence generates exactly the same result
          tokens_on_multiple_lines = first token
          tokens_on_multiple_lines = second token

          # commas may be escaped in tokens
          commas.escaped = Hi\, what'up?

NOTE: this class has not been written for performance nor low memory usage. In fact, it's way slower than it could be and generates too much memory garbage. But since performance is not an issue during intialization (and there is not much time to improve it), I wrote it this way. If you don't like it, go ahead and tune it up!

Since:
  Commons Collections 1.0
Version:
  $Revision: 1.23 $ $Date: 2004/06/21 23:39:25 $
Author:
  Stefano Mazzocchi, Jon S. Stevens, Dave Bryson, Jason van Zyl, Geir Magnusson Jr., Leon Messerschmidt, Kent Johnson, Daniel Rall, Ilkka Priha, Janek Bogucki, Mohan Kishore, Stephen Colebourne
See Also:
  Serialized Form

Field Summary
`protected String` `basePath` Base path of the configuration file used to create this ExtendedProperties object.
`protected static String` `END_TOKEN`
`protected String` `file` The file connected to this repository (holding comments and such).
`protected String` `fileSeparator` File separator.
`protected static String` `include` This is the name of the property that can point to other properties file for including other properties files.
`protected boolean` `isInitialized` Has this configuration been intialized.
`protected ArrayList` `keysAsListed` These are the keys in the order they listed in the configuration file.
`protected static String` `START_TOKEN`

Constructor Summary
`ExtendedProperties()` Creates an empty extended properties object.
`ExtendedProperties(String file)` Creates and loads the extended properties from the specified file.
`ExtendedProperties(String file, String defaultFile)` Creates and loads the extended properties from the specified file.

Method Summary
`void` `addProperty(String key, Object value)` Add a property to the configuration.
`void` `clearProperty(String key)` Clear a property in the configuration.
`void` `combine(ExtendedProperties props)` Combines an existing Hashtable with this Hashtable.
`static ExtendedProperties` `convertProperties(Properties props)` Convert a standard properties class into a configuration class.
`void` `display()` Display the configuration for debugging purposes to System.out.
`boolean` `getBoolean(String key)` Get a boolean associated with the given configuration key.
`boolean` `getBoolean(String key, boolean defaultValue)` Get a boolean associated with the given configuration key.
`Boolean` `getBoolean(String key, Boolean defaultValue)` Get a boolean associated with the given configuration key.
`byte` `getByte(String key)` Get a byte associated with the given configuration key.
`byte` `getByte(String key, byte defaultValue)` Get a byte associated with the given configuration key.
`Byte` `getByte(String key, Byte defaultValue)` Get a byte associated with the given configuration key.
`double` `getDouble(String key)` Get a double associated with the given configuration key.
`double` `getDouble(String key, double defaultValue)` Get a double associated with the given configuration key.
`Double` `getDouble(String key, Double defaultValue)` Get a double associated with the given configuration key.
`float` `getFloat(String key)` Get a float associated with the given configuration key.
`float` `getFloat(String key, float defaultValue)` Get a float associated with the given configuration key.
`Float` `getFloat(String key, Float defaultValue)` Get a float associated with the given configuration key.
`String` `getInclude()` Gets the property value for including other properties files.
`int` `getInt(String name)` The purpose of this method is to get the configuration resource with the given name as an integer.
`int` `getInt(String name, int def)` The purpose of this method is to get the configuration resource with the given name as an integer, or a default value.
`int` `getInteger(String key)` Get a int associated with the given configuration key.
`int` `getInteger(String key, int defaultValue)` Get a int associated with the given configuration key.
`Integer` `getInteger(String key, Integer defaultValue)` Get a int associated with the given configuration key.
`Iterator` `getKeys()` Get the list of the keys contained in the configuration repository.
`Iterator` `getKeys(String prefix)` Get the list of the keys contained in the configuration repository that match the specified prefix.
`long` `getLong(String key)` Get a long associated with the given configuration key.
`long` `getLong(String key, long defaultValue)` Get a long associated with the given configuration key.
`Long` `getLong(String key, Long defaultValue)` Get a long associated with the given configuration key.
`Properties` `getProperties(String key)` Get a list of properties associated with the given configuration key.
`Properties` `getProperties(String key, Properties defaults)` Get a list of properties associated with the given configuration key.
`Object` `getProperty(String key)` Gets a property from the configuration.
`short` `getShort(String key)` Get a short associated with the given configuration key.
`short` `getShort(String key, short defaultValue)` Get a short associated with the given configuration key.
`Short` `getShort(String key, Short defaultValue)` Get a short associated with the given configuration key.
`String` `getString(String key)` Get a string associated with the given configuration key.
`String` `getString(String key, String defaultValue)` Get a string associated with the given configuration key.
`String[]` `getStringArray(String key)` Get an array of strings associated with the given configuration key.
`Vector` `getVector(String key)` Get a Vector of strings associated with the given configuration key.
`Vector` `getVector(String key, Vector defaultValue)` Get a Vector of strings associated with the given configuration key.
`protected String` `interpolate(String base)` Interpolate key names to handle ${key} stuff
`protected String` `interpolateHelper(String base, List priorVariables)` Recursive handler for multiple levels of interpolation.
`boolean` `isInitialized()` Indicate to client code whether property resources have been initialized or not.
`void` `load(InputStream input)` Load the properties from the given input stream.
`void` `load(InputStream input, String enc)` Load the properties from the given input stream and using the specified encoding.
`void` `save(OutputStream output, String header)` Save the properties to the given output stream.
`void` `setInclude(String inc)` Sets the property value for including other properties files.
`void` `setProperty(String key, Object value)` Set a property, this will replace any previously set values.
`ExtendedProperties` `subset(String prefix)` Create an ExtendedProperties object that is a subset of this one.
`String` `testBoolean(String value)` Test whether the string represent by value maps to a boolean value or not.

Methods inherited from class java.util.Hashtable
`clear, clone, contains, containsKey, containsValue, elements, entrySet, equals, get, hashCode, isEmpty, keys, keySet, put, putAll, rehash, remove, size, toString, values`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### file

    protected String file

  The file connected to this repository (holding comments and such).

### basePath

    protected String basePath

  Base path of the configuration file used to create this ExtendedProperties object.

### fileSeparator

    protected String fileSeparator

  File separator.

### isInitialized

    protected boolean isInitialized

  Has this configuration been intialized.

### include

    protected static String include

  This is the name of the property that can point to other properties file for including other properties files.

### keysAsListed

    protected ArrayList keysAsListed

  These are the keys in the order they listed in the configuration file. This is useful when you wish to perform operations with configuration information in a particular order.

### START_TOKEN

    protected static final String START_TOKEN

See Also:
  Constant Field Values

### END_TOKEN

    protected static final String END_TOKEN

See Also:
  Constant Field Values

Constructor Detail

### ExtendedProperties

    public ExtendedProperties()

  Creates an empty extended properties object.

### ExtendedProperties

    public ExtendedProperties(String file)
                       throws IOException

  Creates and loads the extended properties from the specified file.

Parameters:
  `file` - the filename to load
Throws:
  `IOException` - if a file error occurs

### ExtendedProperties

    public ExtendedProperties(String file,
                              String defaultFile)
                       throws IOException

  Creates and loads the extended properties from the specified file.

Parameters:
  `file` - the filename to load
  `defaultFile` - a second filename to load default values from
Throws:
  `IOException` - if a file error occurs

Method Detail

### interpolate

    protected String interpolate(String base)

  Interpolate key names to handle ${key} stuff

  Parameters:
    `base` - string to interpolate
  Returns:
    returns the key name with the ${key} substituted

### interpolateHelper

    protected String interpolateHelper(String base,
                                       List priorVariables)

  Recursive handler for multiple levels of interpolation. When called the first time, priorVariables should be null.

  Parameters:
    `base` - string with the ${key} variables
    `priorVariables` - serves two purposes: to allow checking for loops, and creating a meaningful exception message should a loop occur. It's 0'th element will be set to the value of base from the first call. All subsequent interpolated variables are added afterward.
  Returns:
    the string with the interpolation taken care of

### isInitialized

    public boolean isInitialized()

  Indicate to client code whether property resources have been initialized or not.

### getInclude

    public String getInclude()

  Gets the property value for including other properties files. By default it is "include".

  Returns:
    A String.

### setInclude

    public void setInclude(String inc)

  Sets the property value for including other properties files. By default it is "include".

  Parameters:
    `inc` - A String.

### load

    public void load(InputStream input)
              throws IOException

  Load the properties from the given input stream.

  Parameters:
    `input` - the InputStream to load from
  Throws:
    `IOException` - if an IO error occurs

### load

    public void load(InputStream input,
                     String enc)
              throws IOException

  Load the properties from the given input stream and using the specified encoding.

  Parameters:
    `input` - the InputStream to load from
    `enc` - the encoding to use
  Throws:
    `IOException` - if an IO error occurs

### getProperty

    public Object getProperty(String key)

  Gets a property from the configuration.

  Parameters:
    `key` - property to retrieve
  Returns:
    value as object. Will return user value if exists, if not then default value if exists, otherwise null

### addProperty

    public void addProperty(String key,
                            Object value)

  Add a property to the configuration. If it already exists then the value stated here will be added to the configuration entry. For example, if `resource.loader = file` is already present in the configuration and you `addProperty("resource.loader", "classpath")` Then you will end up with a Vector like the following: `["file", "classpath"]`

  Parameters:
    `key` - the key to add
    `value` - the value to add

### setProperty

    public void setProperty(String key,
                            Object value)

  Set a property, this will replace any previously set values. Set values is implicitly a call to clearProperty(key), addProperty(key,value).

  Parameters:
    `key` - the key to set
    `value` - the value to set

### save

    public void save(OutputStream output,
                     String header)
              throws IOException

  Save the properties to the given output stream.

  The stream is not closed, but it is flushed.

  Parameters:
    `output` - an OutputStream, may be null
    `header` - a textual comment to act as a file header
  Throws:
    `IOException` - if an IO error occurs

### combine

    public void combine(ExtendedProperties props)

  Combines an existing Hashtable with this Hashtable.

  Warning: It will overwrite previous entries without warning.

  Parameters:
    `props` - the properties to combine

### clearProperty

    public void clearProperty(String key)

  Clear a property in the configuration.

  Parameters:
    `key` - the property key to remove along with corresponding value

### getKeys

    public Iterator getKeys()

  Get the list of the keys contained in the configuration repository.

  Returns:
    an Iterator over the keys

### getKeys

    public Iterator getKeys(String prefix)

  Get the list of the keys contained in the configuration repository that match the specified prefix.

  Parameters:
    `prefix` - the prefix to match
  Returns:
    an Iterator of keys that match the prefix

### subset

    public ExtendedProperties subset(String prefix)

  Create an ExtendedProperties object that is a subset of this one. Take into account duplicate keys by using the setProperty() in ExtendedProperties.

  Parameters:
    `prefix` - the prefix to get a subset for
  Returns:
    a new independent ExtendedProperties

### display

    public void display()

  Display the configuration for debugging purposes to System.out.

### getString

    public String getString(String key)

  Get a string associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
  Returns:
    The associated string.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a String.

### getString

    public String getString(String key,
                            String defaultValue)

  Get a string associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
    `defaultValue` - The default value.
  Returns:
    The associated string if key is found, default value otherwise.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a String.

### getProperties

    public Properties getProperties(String key)

  Get a list of properties associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
  Returns:
    The associated properties if key is found.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a String/Vector.
    `IllegalArgumentException` - if one of the tokens is malformed (does not contain an equals sign).

### getProperties

    public Properties getProperties(String key,
                                    Properties defaults)

  Get a list of properties associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
  Returns:
    The associated properties if key is found.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a String/Vector.
    `IllegalArgumentException` - if one of the tokens is malformed (does not contain an equals sign).

### getStringArray

    public String[] getStringArray(String key)

  Get an array of strings associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
  Returns:
    The associated string array if key is found.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a String/Vector.

### getVector

    public Vector getVector(String key)

  Get a Vector of strings associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
  Returns:
    The associated Vector.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a Vector.

### getVector

    public Vector getVector(String key,
                            Vector defaultValue)

  Get a Vector of strings associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
    `defaultValue` - The default value.
  Returns:
    The associated Vector.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a Vector.

### getBoolean

    public boolean getBoolean(String key)

  Get a boolean associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
  Returns:
    The associated boolean.
  Throws:
    `NoSuchElementException` - is thrown if the key doesn't map to an existing object.
    `ClassCastException` - is thrown if the key maps to an object that is not a Boolean.

### getBoolean

    public boolean getBoolean(String key,
                              boolean defaultValue)

  Get a boolean associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
    `defaultValue` - The default value.
  Returns:
    The associated boolean.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a Boolean.

### getBoolean

    public Boolean getBoolean(String key,
                              Boolean defaultValue)

  Get a boolean associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
    `defaultValue` - The default value.
  Returns:
    The associated boolean if key is found and has valid format, default value otherwise.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a Boolean.

### testBoolean

    public String testBoolean(String value)

  Test whether the string represent by value maps to a boolean value or not. We will allow `true`, `on`, and `yes` for a `true` boolean value, and `false`, `off`, and `no` for `false` boolean values. Case of value to test for boolean status is ignored.

  Parameters:
    `value` - the value to test for boolean state
  Returns:
    `true` or `false` if the supplied text maps to a boolean value, or `null` otherwise.

### getByte

    public byte getByte(String key)

  Get a byte associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
  Returns:
    The associated byte.
  Throws:
    `NoSuchElementException` - is thrown if the key doesn't map to an existing object.
    `ClassCastException` - is thrown if the key maps to an object that is not a Byte.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### getByte

    public byte getByte(String key,
                        byte defaultValue)

  Get a byte associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
    `defaultValue` - The default value.
  Returns:
    The associated byte.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a Byte.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### getByte

    public Byte getByte(String key,
                        Byte defaultValue)

  Get a byte associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
    `defaultValue` - The default value.
  Returns:
    The associated byte if key is found and has valid format, default value otherwise.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a Byte.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### getShort

    public short getShort(String key)

  Get a short associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
  Returns:
    The associated short.
  Throws:
    `NoSuchElementException` - is thrown if the key doesn't map to an existing object.
    `ClassCastException` - is thrown if the key maps to an object that is not a Short.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### getShort

    public short getShort(String key,
                          short defaultValue)

  Get a short associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
    `defaultValue` - The default value.
  Returns:
    The associated short.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a Short.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### getShort

    public Short getShort(String key,
                          Short defaultValue)

  Get a short associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
    `defaultValue` - The default value.
  Returns:
    The associated short if key is found and has valid format, default value otherwise.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a Short.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### getInt

    public int getInt(String name)

  The purpose of this method is to get the configuration resource with the given name as an integer.

  Parameters:
    `name` - The resource name.
  Returns:
    The value of the resource as an integer.

### getInt

    public int getInt(String name,
                      int def)

  The purpose of this method is to get the configuration resource with the given name as an integer, or a default value.

  Parameters:
    `name` - The resource name
    `def` - The default value of the resource.
  Returns:
    The value of the resource as an integer.

### getInteger

    public int getInteger(String key)

  Get a int associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
  Returns:
    The associated int.
  Throws:
    `NoSuchElementException` - is thrown if the key doesn't map to an existing object.
    `ClassCastException` - is thrown if the key maps to an object that is not a Integer.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### getInteger

    public int getInteger(String key,
                          int defaultValue)

  Get a int associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
    `defaultValue` - The default value.
  Returns:
    The associated int.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a Integer.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### getInteger

    public Integer getInteger(String key,
                              Integer defaultValue)

  Get a int associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
    `defaultValue` - The default value.
  Returns:
    The associated int if key is found and has valid format, default value otherwise.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a Integer.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### getLong

    public long getLong(String key)

  Get a long associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
  Returns:
    The associated long.
  Throws:
    `NoSuchElementException` - is thrown if the key doesn't map to an existing object.
    `ClassCastException` - is thrown if the key maps to an object that is not a Long.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### getLong

    public long getLong(String key,
                        long defaultValue)

  Get a long associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
    `defaultValue` - The default value.
  Returns:
    The associated long.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a Long.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### getLong

    public Long getLong(String key,
                        Long defaultValue)

  Get a long associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
    `defaultValue` - The default value.
  Returns:
    The associated long if key is found and has valid format, default value otherwise.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a Long.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### getFloat

    public float getFloat(String key)

  Get a float associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
  Returns:
    The associated float.
  Throws:
    `NoSuchElementException` - is thrown if the key doesn't map to an existing object.
    `ClassCastException` - is thrown if the key maps to an object that is not a Float.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### getFloat

    public float getFloat(String key,
                          float defaultValue)

  Get a float associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
    `defaultValue` - The default value.
  Returns:
    The associated float.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a Float.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### getFloat

    public Float getFloat(String key,
                          Float defaultValue)

  Get a float associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
    `defaultValue` - The default value.
  Returns:
    The associated float if key is found and has valid format, default value otherwise.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a Float.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### getDouble

    public double getDouble(String key)

  Get a double associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
  Returns:
    The associated double.
  Throws:
    `NoSuchElementException` - is thrown if the key doesn't map to an existing object.
    `ClassCastException` - is thrown if the key maps to an object that is not a Double.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### getDouble

    public double getDouble(String key,
                            double defaultValue)

  Get a double associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
    `defaultValue` - The default value.
  Returns:
    The associated double.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a Double.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### getDouble

    public Double getDouble(String key,
                            Double defaultValue)

  Get a double associated with the given configuration key.

  Parameters:
    `key` - The configuration key.
    `defaultValue` - The default value.
  Returns:
    The associated double if key is found and has valid format, default value otherwise.
  Throws:
    `ClassCastException` - is thrown if the key maps to an object that is not a Double.
    `NumberFormatException` - is thrown if the value mapped by the key has not a valid number format.

### convertProperties

    public static ExtendedProperties convertProperties(Properties props)

  Convert a standard properties class into a configuration class.

  Parameters:
    `props` - the properties object to convert
  Returns:
    new ExtendedProperties created from props

Copyright © 2001-2005 Apache Software Foundation. All Rights Reserved.